import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class TANKS extends PApplet {

ArrayList<Bullet> bullets=new ArrayList<Bullet>();
boolean[] keys=new boolean[256];
int[] tmColors={color(20, 200, 20), color(20, 20, 200), color(200, 20, 20), color(100), color(200, 200, 20), color(20, 200, 200), color(200, 20, 200), color(200)};
ArrayList<Tank> tanks=new ArrayList<Tank>();
ArrayList<Tank>[] teams = new ArrayList[8];
int[] tKills=new int[8];
int s=3000;
int scoreT;
int scoreK;
Tank player;

public void setup() {
  //size(500, 500);
  
  for (int i=0; i<8; i++)teams[i]=new ArrayList<Tank>();
  for (int i=0; i<25; i++) {
    Tank t=new Tank(random(s), random(s), i%8);
    tanks.add(t);
    teams[i%8].add(t);
  }
  int r=(int)random(tanks.size());
  tanks.get(r).pc=true;
  player=tanks.get(r);
  strokeWeight(5);
  textAlign(CENTER, CENTER);
  textSize(100);
}


public void draw() {
  if (player.hp<=0&&teams[player.team].size()>0) {
    player=teams[player.team].get(0);
  }
  if (millis()%1000<=10) {
    Tank t=new Tank(random(s), random(s), (int)random(8));
    tanks.add(t);
    teams[t.team].add(t);
  }
  background(100, 150, 50);
  pushMatrix();
  if (tanks.size()>0)translate(width/2-player.pos.x, height/2-player.pos.y);
  for (int i=0; i<s/100; i++) {
    for (int j=0; j<s/100; j++) {
      fill(0, 0);
      stroke(200, 150, 60);
      rect(i*100, j*100, 100, 100);
    }
  }
  stroke(0);
  for (int i=0; i<bullets.size(); i++) {
    if (i<0)continue;
    Bullet b=bullets.get(i);
    b.update();
    if ((b.pos.x>s||b.pos.x<0)||(b.pos.y>s||b.pos.y<0)) {
      bullets.remove(b);
      i--;
      continue;
    }
    for (int j=0; j<tanks.size(); j++) {
      Tank t=tanks.get(j);
      if (dist(b.pos.x, b.pos.y, t.pos.x, t.pos.y)<25&&b.owner!=t&&t.team!=b.owner.team) {
        t.hp-=b.dmg;
        if (t.hp<=0) {
          teams[t.team].remove(t);
          tanks.remove(t);

          j--;
          b.owner.kills++;
          tKills[b.owner.team]++;
          if(b.owner==player)scoreK++;
        }
        bullets.remove(b);
        i--;
        continue;
      }
    }
  }  
  for (int i=0; i<tanks.size(); i++) {
    Tank t=tanks.get(i);
    t.update();
  }
  popMatrix();
  fill(0);
  textSize(50);
  textAlign(LEFT, TOP);
  scoreT=(int)(millis()/1000);
  text("Time: "+scoreT, 50, 50);
  for (int i=0; i<8; i++) {
    fill(tmColors[i]);
    textAlign(LEFT, TOP);
    text(teams[i].size(), 50, i*50+150);
    textAlign(RIGHT, TOP);
    text(tKills[i], width-50, i*50+150);
  }
  fill(0);
  textAlign(RIGHT, TOP);
  text("Kills: "+scoreK, width-50, 50);
}

public void keyPressed() {
  if (key<256)keys[key]=true;
  if (keyCode==UP)keys['w']=true;
  else if (keyCode==LEFT)keys['a']=true;
  else if (keyCode==DOWN)keys['s']=true;
  else if (keyCode==RIGHT)keys['d']=true;
}

public void keyReleased() {
  if (key<256)keys[key]=false;
  if (keyCode==UP)keys['w']=false;
  else if (keyCode==LEFT)keys['a']=false;
  else if (keyCode==DOWN)keys['s']=false;
  else if (keyCode==RIGHT)keys['d']=false;
}
class Bullet{
  
  PVector pos;
  PVector dir;
  float spd=10;
  Tank owner;
  float dmg;
  
  Bullet(PVector pos_,PVector dir_,Tank o,float dmg_){
    pos=pos_;
    dir=dir_;
    dir.setMag(spd);
    owner=o;
    dmg=dmg_;
  }
  
  public void update(){
    moveBullet();
    drawBullet();
  }
  
  public void moveBullet(){
    pos.add(dir);
  }
  
  public void drawBullet(){
    fill(0);
    ellipse(pos.x,pos.y,7*dmg,7*dmg);
  }
  
}
class Tank {

  PVector pos;
  PVector aim;
  float hp=5;
  int c;
  int team;
  boolean pc=false;
  float spd=5;
  int cooldown=0;
  int ID;
  float lowest;
  int type;
  int kills=0;

  Tank(float x, float y, int team_) {
    pos=new PVector(x, y);
    team=team_;
    type=(int)random(3);
    c=tmColors[team];
  }

  public void update() {
    if (player==this)pc=true;
    else pc=false;
    cooldown--;
    moveTank();
    drawTank();
    if (cooldown<=0)shoot();
  }

  public void moveTank() {
    if (pc) {
      PVector vel=new PVector(0, 0);
      if (keys['w'])vel.y-=spd;
      if (keys['a'])vel.x-=spd;
      if (keys['s'])vel.y+=spd;
      if (keys['d'])vel.x+=spd;
      vel.setMag(spd);
      pos.add(vel);
      aim=new PVector(mouseX-(width/2-pos.x), mouseY-(height/2-pos.y));
      //aim.setMag(2);
    } else {
      pos.x+=(noise(team+millis()*ID/100000)*2-1)*spd;
      pos.y+=(noise(team+millis()*ID/10000)*2-1)*spd;
      lowest=999999;
      int lID=0;
      for (int i=0; i<tanks.size(); i++) {
        Tank t=tanks.get(i);
        if (t!=this&&t.team!=team) {
          float d=(t.pos.x-pos.x)*(t.pos.x-pos.x)+(t.pos.y-pos.y)*(t.pos.y-pos.y);
          if (d<lowest) {
            lowest=d;
            lID=i;
          }
        }
      }
      Tank t=tanks.get(lID);
      aim=new PVector(t.pos.x-pos.x, t.pos.y-pos.y);
      //aim.setMag(2);
    }
    pos.x=constrain(pos.x, 0, s);
    pos.y=constrain(pos.y, 0, s);
  }

  public void shoot() {
    if (pc) {
      if (mousePressed) {
        if (type==0) {
          bullets.add(new Bullet(new PVector(pos.x, pos.y), new PVector((mouseX-(width/2-pos.x))-pos.x, (mouseY-(height/2-pos.y))-pos.y), this, 1));   
          cooldown=10;
        } else if (type==1) {
          int spray=50;
          bullets.add(new Bullet(new PVector(pos.x, pos.y), new PVector((mouseX-(width/2-pos.x))-pos.x, (mouseY-(height/2-pos.y))-pos.y), this, 1));   
          bullets.add(new Bullet(new PVector(pos.x+random(-20,20), pos.y+random(-20,20)), new PVector((mouseX+random(-spray,spray)-(width/2-pos.x))-pos.x, (mouseY+random(-spray,spray)-(height/2-pos.y))-pos.y), this, 1));
          bullets.add(new Bullet(new PVector(pos.x+random(-20,20), pos.y+random(-20,20)), new PVector((mouseX+random(-spray,spray)-(width/2-pos.x))-pos.x, (mouseY+random(-spray,spray)-(height/2-pos.y))-pos.y), this, 1)); 
          bullets.add(new Bullet(new PVector(pos.x+random(-20,20), pos.y+random(-20,20)), new PVector((mouseX+random(-spray,spray)-(width/2-pos.x))-pos.x, (mouseY+random(-spray,spray)-(height/2-pos.y))-pos.y), this, 1)); 
          cooldown=30;
        } else if (type==2) {
          bullets.add(new Bullet(new PVector(pos.x, pos.y), new PVector((mouseX-(width/2-pos.x))-pos.x, (mouseY-(height/2-pos.y))-pos.y), this, 0.5f)); 
          cooldown=5;
        } else if (type==3) {
          bullets.add(new Bullet(new PVector(pos.x, pos.y), new PVector((mouseX-(width/2-pos.x))-pos.x, (mouseY-(height/2-pos.y))-pos.y), this, 5)); 
          cooldown=30;
        }
      }
    } else if (lowest<500000) {
      if (type==0) {
        bullets.add(new Bullet(new PVector(pos.x, pos.y), new PVector(aim.x, aim.y), this, 1)); 
        cooldown=10;
      } else if (type==1) {
        int spray=50;
        bullets.add(new Bullet(new PVector(pos.x, pos.y), new PVector(aim.x, aim.y), this, 1)); 
        bullets.add(new Bullet(new PVector(pos.x+random(-20,20), pos.y+random(20)), new PVector(aim.x+random(-spray,spray), aim.y+random(-spray,spray)), this, 1)); 
        bullets.add(new Bullet(new PVector(pos.x+random(-20,20), pos.y+random(20)), new PVector(aim.x+random(-spray,spray), aim.y+random(-spray,spray)), this, 1)); 
        bullets.add(new Bullet(new PVector(pos.x+random(-20,20), pos.y+random(20)), new PVector(aim.x+random(-spray,spray), aim.y+random(-spray,spray)), this, 1)); 
        cooldown=30;
      } else if (type==2) {
        bullets.add(new Bullet(new PVector(pos.x, pos.y), new PVector(aim.x, aim.y), this, 0.5f)); 
        cooldown=5;
      }
    }
  }


  public void drawTank() {
    fill(c);
    pushMatrix();
    translate(pos.x, pos.y);
    ellipse(0, 0, 50, 50);
    fill(0);
    textAlign(CENTER, CENTER);
    textSize(20);
    text((int)ceil(hp), 0, -1);
    fill(125);
    if (pc)rotate(-atan2(pos.x-aim.x, pos.y-aim.y)-HALF_PI);
    else rotate(-atan2(aim.x, aim.y)+HALF_PI);  
    rect(20, -5, 20, 10);
    popMatrix();
  }
}
  public void settings() {  fullScreen(); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--present", "--window-color=#000000", "--hide-stop", "TANKS" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
