class Tank {

  PVector pos;
  PVector aim;
  float hp=5;
  color c;
  int team;
  boolean pc=false;
  float spd=5;
  int cooldown=0;
  int ID;
  float lowest;
  int type;
  int kills=0;

  Tank(float x, float y, int team_) {
    pos=new PVector(x, y);
    team=team_;
    type=(int)random(3);
    c=tmColors[team];
  }

  void update() {
    if (player==this)pc=true;
    else pc=false;
    cooldown--;
    moveTank();
    drawTank();
    if (cooldown<=0)shoot();
  }

  void moveTank() {
    if (pc) {
      PVector vel=new PVector(0, 0);
      if (keys['w'])vel.y-=spd;
      if (keys['a'])vel.x-=spd;
      if (keys['s'])vel.y+=spd;
      if (keys['d'])vel.x+=spd;
      vel.setMag(spd);
      pos.add(vel);
      aim=new PVector(mouseX-(width/2-pos.x), mouseY-(height/2-pos.y));
      //aim.setMag(2);
    } else {
      pos.x+=(noise(team+millis()*ID/100000)*2-1)*spd;
      pos.y+=(noise(team+millis()*ID/10000)*2-1)*spd;
      lowest=999999;
      int lID=0;
      for (int i=0; i<tanks.size(); i++) {
        Tank t=tanks.get(i);
        if (t!=this&&t.team!=team) {
          float d=(t.pos.x-pos.x)*(t.pos.x-pos.x)+(t.pos.y-pos.y)*(t.pos.y-pos.y);
          if (d<lowest) {
            lowest=d;
            lID=i;
          }
        }
      }
      Tank t=tanks.get(lID);
      aim=new PVector(t.pos.x-pos.x, t.pos.y-pos.y);
      //aim.setMag(2);
    }
    pos.x=constrain(pos.x, 0, s);
    pos.y=constrain(pos.y, 0, s);
  }

  void shoot() {
    if (pc) {
      if (mousePressed) {
        if (type==0) {
          bullets.add(new Bullet(new PVector(pos.x, pos.y), new PVector((mouseX-(width/2-pos.x))-pos.x, (mouseY-(height/2-pos.y))-pos.y), this, 1));   
          cooldown=10;
        } else if (type==1) {
          int spray=50;
          bullets.add(new Bullet(new PVector(pos.x, pos.y), new PVector((mouseX-(width/2-pos.x))-pos.x, (mouseY-(height/2-pos.y))-pos.y), this, 1));   
          bullets.add(new Bullet(new PVector(pos.x+random(-20,20), pos.y+random(-20,20)), new PVector((mouseX+random(-spray,spray)-(width/2-pos.x))-pos.x, (mouseY+random(-spray,spray)-(height/2-pos.y))-pos.y), this, 1));
          bullets.add(new Bullet(new PVector(pos.x+random(-20,20), pos.y+random(-20,20)), new PVector((mouseX+random(-spray,spray)-(width/2-pos.x))-pos.x, (mouseY+random(-spray,spray)-(height/2-pos.y))-pos.y), this, 1)); 
          bullets.add(new Bullet(new PVector(pos.x+random(-20,20), pos.y+random(-20,20)), new PVector((mouseX+random(-spray,spray)-(width/2-pos.x))-pos.x, (mouseY+random(-spray,spray)-(height/2-pos.y))-pos.y), this, 1)); 
          cooldown=30;
        } else if (type==2) {
          bullets.add(new Bullet(new PVector(pos.x, pos.y), new PVector((mouseX-(width/2-pos.x))-pos.x, (mouseY-(height/2-pos.y))-pos.y), this, 0.5)); 
          cooldown=5;
        } else if (type==3) {
          bullets.add(new Bullet(new PVector(pos.x, pos.y), new PVector((mouseX-(width/2-pos.x))-pos.x, (mouseY-(height/2-pos.y))-pos.y), this, 5)); 
          cooldown=30;
        }
      }
    } else if (lowest<500000) {
      if (type==0) {
        bullets.add(new Bullet(new PVector(pos.x, pos.y), new PVector(aim.x, aim.y), this, 1)); 
        cooldown=10;
      } else if (type==1) {
        int spray=50;
        bullets.add(new Bullet(new PVector(pos.x, pos.y), new PVector(aim.x, aim.y), this, 1)); 
        bullets.add(new Bullet(new PVector(pos.x+random(-20,20), pos.y+random(20)), new PVector(aim.x+random(-spray,spray), aim.y+random(-spray,spray)), this, 1)); 
        bullets.add(new Bullet(new PVector(pos.x+random(-20,20), pos.y+random(20)), new PVector(aim.x+random(-spray,spray), aim.y+random(-spray,spray)), this, 1)); 
        bullets.add(new Bullet(new PVector(pos.x+random(-20,20), pos.y+random(20)), new PVector(aim.x+random(-spray,spray), aim.y+random(-spray,spray)), this, 1)); 
        cooldown=30;
      } else if (type==2) {
        bullets.add(new Bullet(new PVector(pos.x, pos.y), new PVector(aim.x, aim.y), this, 0.5)); 
        cooldown=5;
      }
    }
  }


  void drawTank() {
    fill(c);
    pushMatrix();
    translate(pos.x, pos.y);
    ellipse(0, 0, 50, 50);
    fill(0);
    textAlign(CENTER, CENTER);
    textSize(20);
    text((int)ceil(hp), 0, -1);
    fill(125);
    if (pc)rotate(-atan2(pos.x-aim.x, pos.y-aim.y)-HALF_PI);
    else rotate(-atan2(aim.x, aim.y)+HALF_PI);  
    rect(20, -5, 20, 10);
    popMatrix();
  }
}
